<?php
/*
 * Copyright 2005-2016 OCSInventory-NG/OCSInventory-ocsreports contributors.
 * See the Contributors file for more details about them.
 *
 * This file is part of OCSInventory-NG/OCSInventory-ocsreports.
 *
 * OCSInventory-NG/OCSInventory-ocsreports is free software: you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the License,
 * or (at your option) any later version.
 *
 * OCSInventory-NG/OCSInventory-ocsreports is distributed in the hope that it
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with OCSInventory-NG/OCSInventory-ocsreports. if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

/**
 * Serialize / unserialize the js config from an XML file
 */
class XMLJsSerializer {

    public function serialize($js) {
        $doc_xml = new DOMDocument('1.0', 'UTF-8');
        $js_xml = $doc_xml->createElement('javascripts');
        $doc_xml->appendChild($js_xml);

        foreach ($js as $file) {
            $js_elem_xml = $doc_xml->createElement('file', $file);
            $js_xml->appendChild($js_elem_xml);
        }

        $doc_xml->preserveWhiteSpace = false;
        $doc_xml->formatOutput = true;

        return $doc_xml->saveXML();
    }

    public function unserialize($xml) {
        $js_xml = simplexml_load_string($xml);

        $js = array();
        foreach ($js_xml->{'file'} as $file) {
            $js [] = (string) $file;
        }

        return $js;
    }

}
?>